=== debian/changelog ===
rocm-core (6.4.4-1~exp3) unstable; urgency=medium

  * bumping version for new build

 -- Tim Flink <tflink@tirfa.com>  Mon, 15 Dec 2025 20:50:23 -0600

rocm-core (6.4.4-1~exp2) unstable; urgency=medium

  * updates to address review comments
    - fixed naming of librocm-core-dev
    - fixed upstream URLs
    - removed uneeded Build-Depens
    - reworked descriptions
    - removed ppc64le builds
    - fixed build flags
    - build with system compiler instead of hipcc

 -- Tim Flink <Tim.Flink@amd.com>  Tue, 9 Dec 2025 13:21:14 -0700

rocm-core (6.4.4-1~exp1) unstable; urgency=medium

  * Initial package for rocm-core_6.4.4-1

 -- Tim Flink <Tim.Flink@amd.com>  Fri, 26 Sep 2025 19:27:31 -0600
