=== debian/control ===
Source: rocm-core
Section: devel
Homepage: https://github.com/ROCm/rocm-core
Priority: optional
Standards-Version: 4.7.2
#Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-core
#Vcs-Git: https://salsa.debian.org/rocm-team/rocm-core.git
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Tim Flink <tflink@tirfa.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Rules-Requires-Root: no

Package: librocm-core1
Section: libs
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: provides methods to get information about installed ROCm
 rocm-core can be used to get a ROCm release version in addition to other
 base information like install path.
 .
 rocm-core is not used by all ROCm components and may not provide an accurate
 value for versions if the other component packages are not updated at the
 same time.

Package: librocm-core-dev
Section: libdevel
Architecture: amd64 arm64
Depends:
 librocm-core1 (= ${binary:Version}),
 ${misc:Depends},
Description: provides methods to get information about installed ROCm - headers
 rocm-core can be used to get a ROCm release version in addition to other
 base information like install path.
 .
 rocm-core is not used by all ROCm components and may not provide an accurate
 value for versions if the other component packages are not updated at the
 same time.
 .
 This package provides the librocm-core1 development headers
