=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKE_FLAGS = \
	-DCMAKE_VERBOSE_MAKEFILE=1 \
	-DCPACK_DEB_COMPONENT_INSTALL=OFF \
	-DCPACK_RPM_COMPONENT_INSTALL=OFF \
	-DDISABLE_CPACK=ON \
	-DROCM_VERSION="6.4.4"

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)
