=== debian/tests/control ===
Tests: rocm-core-path.sh
       rocn-core-version.sh
Depends: g++
         librocm-core-dev
Restrictions: superficial, skippable
