=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocm-core-$1.tar.gz%" \
    https://github.com/rocm/rocm-core/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
