## rocm-core 7.1.0

=== debian/changelog ===
rocm-core (7.1.0-0ubuntu1) resolute; urgency=medium

  [ Tim Flink ]
  * d/salsa-ci.yml: adding config so that salsa ci runs for rocm-core
  * d/control: uncommenting Vcs-Browser and Vcs-Git

  [ Bojan Aleksovski ]
  * New upstream version rocm-core 7.1.0
  * d/control: update maintainer to ubuntu devel
  * d/control: enable ppc64el build

 -- Bojan Aleksovski <bojan.aleksovski@canonical.com>  Fri, 30 Jan 2026 12:50:29 +0100

rocm-core (6.4.4-1~exp6) experimental; urgency=medium

  * d/rules: use dpkg-parsechangelog instead of hard-coding required version
    information

 -- Tim Flink <Tim.Flink@amd.com>  Thu, 18 Dec 2025 13:43:28 -0600

rocm-core (6.4.4-1~exp5) UNRELEASED; urgency=medium

  * d/tests/control: fixing syntax of Depends for lintian warning
  * uncommenting Vcs-Browser, Vcs-Git
  * d/control: removing redundant rules-requires-root:no
  * d/watch: upgrading to watch file version 5

 -- Tim Flink <Tim.Flink@amd.com>  Wed, 17 Dec 2025 14:22:21 -0600

rocm-core (6.4.4-1~exp4) UNRELEASED; urgency=medium

  * changing build to be for experimental instead of unstable
  * fixing typo in d/tests/control
  * updating upstream URL to match current project and not project when this
    release was done

 -- Tim Flink <Tim.Flink@amd.com>  Wed, 17 Dec 2025 13:23:48 -0600

rocm-core (6.4.4-1~exp3) UNRELEASED; urgency=medium

  * bumping version for new build

 -- Tim Flink <Tim.Flink@amd.com>  Mon, 15 Dec 2025 20:50:23 -0600

rocm-core (6.4.4-1~exp2) UNRELEASED; urgency=medium

  * updates to address review comments
    - fixed naming of librocm-core-dev
    - fixed upstream URLs
    - removed uneeded Build-Depens
    - reworked descriptions
    - removed ppc64le builds
    - fixed build flags
    - build with system compiler instead of hipcc

 -- Tim Flink <Tim.Flink@amd.com>  Tue, 9 Dec 2025 13:21:14 -0700

rocm-core (6.4.4-1~exp1) UNRELEASED; urgency=medium

  * Initial package for rocm-core_6.4.4-1

 -- Tim Flink <Tim.Flink@amd.com>  Fri, 26 Sep 2025 19:27:31 -0600
