=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: rocm-core
 Section: devel
-Homepage: https://github.com/ROCm/rocm-core
+Homepage: https://github.com/ROCm/rocm-systems/tree/develop/projects/rocm-core
 Priority: optional
 Standards-Version: 4.7.2
-#Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-core
-#Vcs-Git: https://salsa.debian.org/rocm-team/rocm-core.git
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
-Uploaders: Tim Flink <tflink@tirfa.com>
+Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-core
+Vcs-Git: https://salsa.debian.org/rocm-team/rocm-core.git
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Uploaders: Tim Flink <Tim.Flink@amd.com>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
-Rules-Requires-Root: no
 
 Package: librocm-core1
 Section: libs
-Architecture: amd64 arm64
+Architecture: amd64 arm64 ppc64el
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
@@ -28,7 +28,7 @@
 
 Package: librocm-core-dev
 Section: libdevel
-Architecture: amd64 arm64
+Architecture: amd64 arm64 ppc64el
 Depends:
  librocm-core1 (= ${binary:Version}),
  ${misc:Depends},
