=== debian/watch ===
Version: 5

# rocm-core has moved to https://github.com/ROCm/rocm-systems but those tags
# won't work for individual components. This will eventually need to be
# reworked but for now, keeping the watch file pointing at the old repo's tags
# since they are still being updated

Source: https://github.com/ROCm/rocm-core/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocm-core-$1.tar.gz%
